# Add a release plan (deprecated) POST https://app.unleash-instance.example.com/api/admin/projects/{project}/features/{featureName}/environments/{environment}/release_plans Content-Type: application/json **Enterprise feature** Adds a release plan to a specific feature flag and environment. Deprecated, please use /release-plans instead. Reference: https://docs.getunleash.io/api/old-add-release-plan ## OpenAPI Specification ```yaml openapi: 3.1.1 info: title: Add a release plan. version: endpoint_releaseTemplates.oldAddReleasePlan paths: /api/admin/projects/{project}/features/{featureName}/environments/{environment}/release_plans: post: operationId: old-add-release-plan summary: Add a release plan. description: >- **Enterprise feature** Adds a release plan to a specific feature flag and environment. Deprecated, please use /release-plans instead. tags: - - subpackage_releaseTemplates parameters: - name: project in: path required: true schema: type: string - name: featureName in: path required: true schema: type: string - name: environment in: path required: true schema: type: string - name: Authorization in: header description: Header authentication of the form `undefined ` required: true schema: type: string responses: '200': description: '#/components/schemas/releasePlanSchema' content: application/json: schema: $ref: '#/components/schemas/releasePlanSchema' '401': description: >- Authorization information is missing or invalid. Provide a valid API token as the `authorization` header, e.g. `authorization:*.*.my-admin-token`. content: {} '409': description: >- The provided resource can not be created or updated because it would conflict with the current state of the resource or with an already existing resource, respectively. content: {} requestBody: description: '#/components/schemas/releasePlanTemplateIdSchema' content: application/json: schema: $ref: '#/components/schemas/releasePlanTemplateIdSchema' components: schemas: releasePlanTemplateIdSchema: type: object properties: templateId: type: string description: The release plan template's ID. Release template IDs are ulids. required: - templateId ReleasePlanSchemaDiscriminator: type: string enum: - value: plan ReleasePlanMilestoneSchemaTransitionCondition: type: object properties: intervalMinutes: type: integer description: The interval in minutes before transitioning required: - intervalMinutes parametersSchema: type: object additionalProperties: type: string ConstraintSchemaOperator: type: string enum: - value: NOT_IN - value: IN - value: STR_ENDS_WITH - value: STR_STARTS_WITH - value: STR_CONTAINS - value: NUM_EQ - value: NUM_GT - value: NUM_GTE - value: NUM_LT - value: NUM_LTE - value: DATE_AFTER - value: DATE_BEFORE - value: SEMVER_EQ - value: SEMVER_GT - value: SEMVER_LT constraintSchema: type: object properties: contextName: type: string description: The name of the context field that this constraint should apply to. operator: $ref: '#/components/schemas/ConstraintSchemaOperator' description: >- The operator to use when evaluating this constraint. For more information about the various operators, refer to [the strategy constraint operator documentation](https://docs.getunleash.io/concepts/activation-strategies#constraint-operators). caseInsensitive: type: boolean default: false description: >- Whether the operator should be case sensitive or not. Defaults to `false` (being case sensitive). inverted: type: boolean default: false description: >- Whether the result should be negated or not. If `true`, will turn a `true` result into a `false` result and vice versa. values: type: array items: type: string description: >- The context values that should be used for constraint evaluation. Use this property instead of `value` for properties that accept multiple values. value: type: string description: >- The context value that should be used for constraint evaluation. Use this property instead of `values` for properties that only accept single values. required: - contextName - operator CreateStrategyVariantSchemaWeightType: type: string enum: - value: variable - value: fix CreateStrategyVariantSchemaPayloadType: type: string enum: - value: json - value: csv - value: string - value: number CreateStrategyVariantSchemaPayload: type: object properties: type: $ref: '#/components/schemas/CreateStrategyVariantSchemaPayloadType' description: >- The type of the value. Commonly used types are string, number, json and csv. value: type: string description: The actual value of payload required: - type - value createStrategyVariantSchema: type: object properties: name: type: string description: The variant name. Must be unique for this feature flag weight: type: integer description: >- The weight is the likelihood of any one user getting this variant. It is an integer between 0 and 1000. See the section on [variant weights](https://docs.getunleash.io/concepts/feature-flag-variants#variant-weight) for more information weightType: $ref: '#/components/schemas/CreateStrategyVariantSchemaWeightType' description: >- Set to `fix` if this variant must have exactly the weight allocated to it. If the type is `variable`, the weight will adjust so that the total weight of all variants adds up to 1000. Refer to the [variant weight documentation](https://docs.getunleash.io/concepts/feature-flag-variants#variant-weight). stickiness: type: string description: >- The [stickiness](https://docs.getunleash.io/concepts/feature-flag-variants#variant-stickiness) to use for distribution of this variant. Stickiness is how Unleash guarantees that the same user gets the same variant every time payload: $ref: '#/components/schemas/CreateStrategyVariantSchemaPayload' description: Extra data configured for this variant required: - name - weight - weightType - stickiness releasePlanMilestoneStrategySchema: type: object properties: id: type: string description: The milestone strategy's ID. Milestone strategy IDs are ulids. milestoneId: type: string description: The ID of the milestone that this strategy belongs to. sortOrder: type: number format: double description: The order of the strategy in the list title: type: - string - 'null' description: A descriptive title for the strategy strategyName: type: string description: The name of the strategy type parameters: $ref: '#/components/schemas/parametersSchema' description: An object containing the parameters for the strategy constraints: type: array items: $ref: '#/components/schemas/constraintSchema' description: >- A list of the constraints attached to the strategy. See https://docs.getunleash.io/concepts/activation-strategies#constraints variants: type: array items: $ref: '#/components/schemas/createStrategyVariantSchema' description: Strategy level variants segments: type: array items: type: number format: double description: Ids of segments to use for this strategy required: - id - milestoneId - sortOrder - strategyName releasePlanMilestoneSchema: type: object properties: id: type: string description: The milestone's ID. Milestone IDs are ulids. name: type: string description: The name of the milestone. sortOrder: type: integer description: The order of the milestone in the release plan. releasePlanDefinitionId: type: string description: The ID of the release plan/template that this milestone belongs to. startedAt: type: - string - 'null' format: date-time description: The date and time when the milestone was started. transitionCondition: oneOf: - $ref: >- #/components/schemas/ReleasePlanMilestoneSchemaTransitionCondition - type: 'null' description: The condition configuration for the transition progressionExecutedAt: type: - string - 'null' format: date-time description: The date and time when the milestone progression was executed. pausedAt: type: - string - 'null' format: date-time description: The date and time when the milestone was paused. strategies: type: array items: $ref: '#/components/schemas/releasePlanMilestoneStrategySchema' description: A list of strategies that are attached to this milestone. required: - id - name - sortOrder - releasePlanDefinitionId SafeguardSchemaAction: type: object properties: type: type: string description: The type of action to perform. id: type: string description: The ID of the release plan this safeguard applies to. required: - type - id SafeguardTriggerConditionSchemaOperator: type: string enum: - value: '>' - value: < safeguardTriggerConditionSchema: type: object properties: operator: $ref: '#/components/schemas/SafeguardTriggerConditionSchemaOperator' description: The comparison operator for the threshold check. threshold: type: number format: double description: The threshold value to compare against. required: - operator - threshold SafeguardSchemaImpactMetricTimeRange: type: string enum: - value: hour - value: day - value: week - value: month SafeguardSchemaImpactMetricAggregationMode: type: string enum: - value: rps - value: count - value: avg - value: sum - value: p95 - value: p99 - value: p50 SafeguardSchemaImpactMetric: type: object properties: id: type: string description: The unique identifier for this impact metric metricName: type: string description: >- The Prometheus metric series to query. It includes both unleash prefix and metric type and display name timeRange: $ref: '#/components/schemas/SafeguardSchemaImpactMetricTimeRange' description: The time range for the metric data. aggregationMode: $ref: '#/components/schemas/SafeguardSchemaImpactMetricAggregationMode' description: The aggregation mode for the metric data. labelSelectors: type: object additionalProperties: type: array items: type: string description: The selected labels and their values for filtering the metric data. required: - id - metricName - timeRange - aggregationMode - labelSelectors safeguardSchema: type: object properties: id: type: string description: The unique ULID identifier for this safeguard action: $ref: '#/components/schemas/SafeguardSchemaAction' description: The action to take when the safeguard is triggered. triggerCondition: $ref: '#/components/schemas/safeguardTriggerConditionSchema' description: The condition that triggers the safeguard. impactMetric: $ref: '#/components/schemas/SafeguardSchemaImpactMetric' description: The metric configuration used to evaluate the safeguard condition. required: - id - action - triggerCondition - impactMetric releasePlanSchema: type: object properties: id: type: string description: The release plan/template's ID. Release template IDs are ulids. discriminator: $ref: '#/components/schemas/ReleasePlanSchemaDiscriminator' description: A field to distinguish between release plans and release templates. name: type: string description: The name of the release template. description: type: - string - 'null' description: A description of the release template. featureName: type: string description: The name of the feature that uses this release plan. environment: type: string description: The environment that this release plan is for. createdByUserId: type: number format: double description: 'Release template: The ID of the user who created this template.' createdAt: type: string format: date-time description: The date and time that the release template was created. activeMilestoneId: type: - string - 'null' description: The ID of the currently active milestone in this release plan. milestones: type: array items: $ref: '#/components/schemas/releasePlanMilestoneSchema' description: A list of the milestones in this release template. releasePlanTemplateId: type: string description: >- The ID of the release plan template that this release plan is based on. safeguards: type: array items: $ref: '#/components/schemas/safeguardSchema' description: An array of safeguards configured for this release plan. required: - id - discriminator - name - featureName - environment - createdByUserId - createdAt - milestones - releasePlanTemplateId ``` ## SDK Code Examples ```python import requests url = "https://app.unleash-instance.example.com/api/admin/projects/project/features/featureName/environments/environment/release_plans" payload = { "templateId": "01JB9GGTGQYEQ9D40R17T3YVW2" } headers = { "Authorization": "", "Content-Type": "application/json" } response = requests.post(url, json=payload, headers=headers) print(response.json()) ``` ```javascript const url = 'https://app.unleash-instance.example.com/api/admin/projects/project/features/featureName/environments/environment/release_plans'; const options = { method: 'POST', headers: {Authorization: '', 'Content-Type': 'application/json'}, body: '{"templateId":"01JB9GGTGQYEQ9D40R17T3YVW2"}' }; try { const response = await fetch(url, options); const data = await response.json(); console.log(data); } catch (error) { console.error(error); } ``` ```go package main import ( "fmt" "strings" "net/http" "io" ) func main() { url := "https://app.unleash-instance.example.com/api/admin/projects/project/features/featureName/environments/environment/release_plans" payload := strings.NewReader("{\n \"templateId\": \"01JB9GGTGQYEQ9D40R17T3YVW2\"\n}") req, _ := http.NewRequest("POST", url, payload) req.Header.Add("Authorization", "") req.Header.Add("Content-Type", "application/json") res, _ := http.DefaultClient.Do(req) defer res.Body.Close() body, _ := io.ReadAll(res.Body) fmt.Println(res) fmt.Println(string(body)) } ``` ```ruby require 'uri' require 'net/http' url = URI("https://app.unleash-instance.example.com/api/admin/projects/project/features/featureName/environments/environment/release_plans") http = Net::HTTP.new(url.host, url.port) http.use_ssl = true request = Net::HTTP::Post.new(url) request["Authorization"] = '' request["Content-Type"] = 'application/json' request.body = "{\n \"templateId\": \"01JB9GGTGQYEQ9D40R17T3YVW2\"\n}" response = http.request(request) puts response.read_body ``` ```java import com.mashape.unirest.http.HttpResponse; import com.mashape.unirest.http.Unirest; HttpResponse response = Unirest.post("https://app.unleash-instance.example.com/api/admin/projects/project/features/featureName/environments/environment/release_plans") .header("Authorization", "") .header("Content-Type", "application/json") .body("{\n \"templateId\": \"01JB9GGTGQYEQ9D40R17T3YVW2\"\n}") .asString(); ``` ```php request('POST', 'https://app.unleash-instance.example.com/api/admin/projects/project/features/featureName/environments/environment/release_plans', [ 'body' => '{ "templateId": "01JB9GGTGQYEQ9D40R17T3YVW2" }', 'headers' => [ 'Authorization' => '', 'Content-Type' => 'application/json', ], ]); echo $response->getBody(); ``` ```csharp using RestSharp; var client = new RestClient("https://app.unleash-instance.example.com/api/admin/projects/project/features/featureName/environments/environment/release_plans"); var request = new RestRequest(Method.POST); request.AddHeader("Authorization", ""); request.AddHeader("Content-Type", "application/json"); request.AddParameter("application/json", "{\n \"templateId\": \"01JB9GGTGQYEQ9D40R17T3YVW2\"\n}", ParameterType.RequestBody); IRestResponse response = client.Execute(request); ``` ```swift import Foundation let headers = [ "Authorization": "", "Content-Type": "application/json" ] let parameters = ["templateId": "01JB9GGTGQYEQ9D40R17T3YVW2"] as [String : Any] let postData = JSONSerialization.data(withJSONObject: parameters, options: []) let request = NSMutableURLRequest(url: NSURL(string: "https://app.unleash-instance.example.com/api/admin/projects/project/features/featureName/environments/environment/release_plans")! as URL, cachePolicy: .useProtocolCachePolicy, timeoutInterval: 10.0) request.httpMethod = "POST" request.allHTTPHeaderFields = headers request.httpBody = postData as Data let session = URLSession.shared let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in if (error != nil) { print(error as Any) } else { let httpResponse = response as? HTTPURLResponse print(httpResponse) } }) dataTask.resume() ```